import cv2
from matplotlib import pyplot as plt

def lines_hough(image):
    """
    Detect lines in an image using the Hough transform.
    :return: An image with the lines drawn on it.
    """
    return image

def circles(image):
    """
    Detect circles in an image
    :return: An image with the circles drawn on it.
    """
    return image

def corners(image):
    """
    Detect corners in an image
    :return: An image with the corners drawn on it.
    """
    return image

def circle_ellipse(image):
    """
    Detect circles and ellipses in an image
    :return: An image with the circles and ellipses drawn on it.
    """
    return image

def edges_canny(image):
    """
    Detect edges in an image using the Canny transform.
    :return: An image with the edges drawn on it.
    """
    return image

def edges_find_contours(image):
    """
    Find edges in an image using the Canny transform and contours.
    :return: An image with the edges drawn on it.
    """
    return image

if __name__ == "__main__":
    image = cv2.imread("images/simba.jpg", cv2.IMREAD_GRAYSCALE)
    lines = lines_hough(image)
    circles = circles(image)
    corners = corners(image)
    circle_ellipse = circle_ellipse(image)
    edges_canny = edges_canny(image)
    edges_find_contours = edges_find_contours(image)

    f, axarr = plt.subplots(3, 3)
    axarr[0, 0].imshow(image, cmap='gray')
    axarr[0, 0].set_title('Original')
    axarr[0, 1].imshow(lines, cmap='gray')
    axarr[0, 1].set_title('Lines')
    axarr[1, 0].imshow(circles, cmap='gray')
    axarr[1, 0].set_title('Circles')
    axarr[1, 1].imshow(corners, cmap='gray')
    axarr[1, 1].set_title('Corners')
    axarr[2, 0].imshow(circle_ellipse, cmap='gray')
    axarr[2, 0].set_title('Circles and Ellipses')
    axarr[2, 1].imshow(edges_canny, cmap='gray')
    axarr[2, 1].set_title('Edges (Canny)')
    axarr[2, 2].imshow(edges_find_contours, cmap='gray')
    axarr[2, 2].set_title('Edges (Find Contours)')
    plt.show()